"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserializeAws_restJson1UntagResourceCommand = exports.deserializeAws_restJson1TagResourceCommand = exports.deserializeAws_restJson1PutResourcePolicyCommand = exports.deserializeAws_restJson1ListTagsForResourceCommand = exports.deserializeAws_restJson1ListServicesCommand = exports.deserializeAws_restJson1ListRoutesCommand = exports.deserializeAws_restJson1ListEnvironmentVpcsCommand = exports.deserializeAws_restJson1ListEnvironmentsCommand = exports.deserializeAws_restJson1ListApplicationsCommand = exports.deserializeAws_restJson1GetServiceCommand = exports.deserializeAws_restJson1GetRouteCommand = exports.deserializeAws_restJson1GetResourcePolicyCommand = exports.deserializeAws_restJson1GetEnvironmentCommand = exports.deserializeAws_restJson1GetApplicationCommand = exports.deserializeAws_restJson1DeleteServiceCommand = exports.deserializeAws_restJson1DeleteRouteCommand = exports.deserializeAws_restJson1DeleteResourcePolicyCommand = exports.deserializeAws_restJson1DeleteEnvironmentCommand = exports.deserializeAws_restJson1DeleteApplicationCommand = exports.deserializeAws_restJson1CreateServiceCommand = exports.deserializeAws_restJson1CreateRouteCommand = exports.deserializeAws_restJson1CreateEnvironmentCommand = exports.deserializeAws_restJson1CreateApplicationCommand = exports.serializeAws_restJson1UntagResourceCommand = exports.serializeAws_restJson1TagResourceCommand = exports.serializeAws_restJson1PutResourcePolicyCommand = exports.serializeAws_restJson1ListTagsForResourceCommand = exports.serializeAws_restJson1ListServicesCommand = exports.serializeAws_restJson1ListRoutesCommand = exports.serializeAws_restJson1ListEnvironmentVpcsCommand = exports.serializeAws_restJson1ListEnvironmentsCommand = exports.serializeAws_restJson1ListApplicationsCommand = exports.serializeAws_restJson1GetServiceCommand = exports.serializeAws_restJson1GetRouteCommand = exports.serializeAws_restJson1GetResourcePolicyCommand = exports.serializeAws_restJson1GetEnvironmentCommand = exports.serializeAws_restJson1GetApplicationCommand = exports.serializeAws_restJson1DeleteServiceCommand = exports.serializeAws_restJson1DeleteRouteCommand = exports.serializeAws_restJson1DeleteResourcePolicyCommand = exports.serializeAws_restJson1DeleteEnvironmentCommand = exports.serializeAws_restJson1DeleteApplicationCommand = exports.serializeAws_restJson1CreateServiceCommand = exports.serializeAws_restJson1CreateRouteCommand = exports.serializeAws_restJson1CreateEnvironmentCommand = exports.serializeAws_restJson1CreateApplicationCommand = void 0;
const protocol_http_1 = require("@aws-sdk/protocol-http");
const smithy_client_1 = require("@aws-sdk/smithy-client");
const uuid_1 = require("uuid");
const MigrationHubRefactorSpacesServiceException_1 = require("../models/MigrationHubRefactorSpacesServiceException");
const models_0_1 = require("../models/models_0");
const serializeAws_restJson1CreateApplicationCommand = async (input, context) => {
    var _a;
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` +
        "/environments/{EnvironmentIdentifier}/applications";
    if (input.EnvironmentIdentifier !== undefined) {
        const labelValue = input.EnvironmentIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: EnvironmentIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{EnvironmentIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: EnvironmentIdentifier.");
    }
    let body;
    body = JSON.stringify({
        ...(input.ApiGatewayProxy !== undefined &&
            input.ApiGatewayProxy !== null && {
            ApiGatewayProxy: serializeAws_restJson1ApiGatewayProxyInput(input.ApiGatewayProxy, context),
        }),
        ClientToken: (_a = input.ClientToken) !== null && _a !== void 0 ? _a : (0, uuid_1.v4)(),
        ...(input.Name !== undefined && input.Name !== null && { Name: input.Name }),
        ...(input.ProxyType !== undefined && input.ProxyType !== null && { ProxyType: input.ProxyType }),
        ...(input.Tags !== undefined && input.Tags !== null && { Tags: serializeAws_restJson1TagMap(input.Tags, context) }),
        ...(input.VpcId !== undefined && input.VpcId !== null && { VpcId: input.VpcId }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1CreateApplicationCommand = serializeAws_restJson1CreateApplicationCommand;
const serializeAws_restJson1CreateEnvironmentCommand = async (input, context) => {
    var _a;
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/environments";
    let body;
    body = JSON.stringify({
        ClientToken: (_a = input.ClientToken) !== null && _a !== void 0 ? _a : (0, uuid_1.v4)(),
        ...(input.Description !== undefined && input.Description !== null && { Description: input.Description }),
        ...(input.Name !== undefined && input.Name !== null && { Name: input.Name }),
        ...(input.NetworkFabricType !== undefined &&
            input.NetworkFabricType !== null && { NetworkFabricType: input.NetworkFabricType }),
        ...(input.Tags !== undefined && input.Tags !== null && { Tags: serializeAws_restJson1TagMap(input.Tags, context) }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1CreateEnvironmentCommand = serializeAws_restJson1CreateEnvironmentCommand;
const serializeAws_restJson1CreateRouteCommand = async (input, context) => {
    var _a;
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` +
        "/environments/{EnvironmentIdentifier}/applications/{ApplicationIdentifier}/routes";
    if (input.EnvironmentIdentifier !== undefined) {
        const labelValue = input.EnvironmentIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: EnvironmentIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{EnvironmentIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: EnvironmentIdentifier.");
    }
    if (input.ApplicationIdentifier !== undefined) {
        const labelValue = input.ApplicationIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ApplicationIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{ApplicationIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ApplicationIdentifier.");
    }
    let body;
    body = JSON.stringify({
        ClientToken: (_a = input.ClientToken) !== null && _a !== void 0 ? _a : (0, uuid_1.v4)(),
        ...(input.RouteType !== undefined && input.RouteType !== null && { RouteType: input.RouteType }),
        ...(input.ServiceIdentifier !== undefined &&
            input.ServiceIdentifier !== null && { ServiceIdentifier: input.ServiceIdentifier }),
        ...(input.Tags !== undefined && input.Tags !== null && { Tags: serializeAws_restJson1TagMap(input.Tags, context) }),
        ...(input.UriPathRoute !== undefined &&
            input.UriPathRoute !== null && {
            UriPathRoute: serializeAws_restJson1UriPathRouteInput(input.UriPathRoute, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1CreateRouteCommand = serializeAws_restJson1CreateRouteCommand;
const serializeAws_restJson1CreateServiceCommand = async (input, context) => {
    var _a;
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` +
        "/environments/{EnvironmentIdentifier}/applications/{ApplicationIdentifier}/services";
    if (input.EnvironmentIdentifier !== undefined) {
        const labelValue = input.EnvironmentIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: EnvironmentIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{EnvironmentIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: EnvironmentIdentifier.");
    }
    if (input.ApplicationIdentifier !== undefined) {
        const labelValue = input.ApplicationIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ApplicationIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{ApplicationIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ApplicationIdentifier.");
    }
    let body;
    body = JSON.stringify({
        ClientToken: (_a = input.ClientToken) !== null && _a !== void 0 ? _a : (0, uuid_1.v4)(),
        ...(input.Description !== undefined && input.Description !== null && { Description: input.Description }),
        ...(input.EndpointType !== undefined && input.EndpointType !== null && { EndpointType: input.EndpointType }),
        ...(input.LambdaEndpoint !== undefined &&
            input.LambdaEndpoint !== null && {
            LambdaEndpoint: serializeAws_restJson1LambdaEndpointInput(input.LambdaEndpoint, context),
        }),
        ...(input.Name !== undefined && input.Name !== null && { Name: input.Name }),
        ...(input.Tags !== undefined && input.Tags !== null && { Tags: serializeAws_restJson1TagMap(input.Tags, context) }),
        ...(input.UrlEndpoint !== undefined &&
            input.UrlEndpoint !== null && {
            UrlEndpoint: serializeAws_restJson1UrlEndpointInput(input.UrlEndpoint, context),
        }),
        ...(input.VpcId !== undefined && input.VpcId !== null && { VpcId: input.VpcId }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1CreateServiceCommand = serializeAws_restJson1CreateServiceCommand;
const serializeAws_restJson1DeleteApplicationCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` +
        "/environments/{EnvironmentIdentifier}/applications/{ApplicationIdentifier}";
    if (input.EnvironmentIdentifier !== undefined) {
        const labelValue = input.EnvironmentIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: EnvironmentIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{EnvironmentIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: EnvironmentIdentifier.");
    }
    if (input.ApplicationIdentifier !== undefined) {
        const labelValue = input.ApplicationIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ApplicationIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{ApplicationIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ApplicationIdentifier.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "DELETE",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DeleteApplicationCommand = serializeAws_restJson1DeleteApplicationCommand;
const serializeAws_restJson1DeleteEnvironmentCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/environments/{EnvironmentIdentifier}";
    if (input.EnvironmentIdentifier !== undefined) {
        const labelValue = input.EnvironmentIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: EnvironmentIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{EnvironmentIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: EnvironmentIdentifier.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "DELETE",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DeleteEnvironmentCommand = serializeAws_restJson1DeleteEnvironmentCommand;
const serializeAws_restJson1DeleteResourcePolicyCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/resourcepolicy/{Identifier}";
    if (input.Identifier !== undefined) {
        const labelValue = input.Identifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: Identifier.");
        }
        resolvedPath = resolvedPath.replace("{Identifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: Identifier.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "DELETE",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DeleteResourcePolicyCommand = serializeAws_restJson1DeleteResourcePolicyCommand;
const serializeAws_restJson1DeleteRouteCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` +
        "/environments/{EnvironmentIdentifier}/applications/{ApplicationIdentifier}/routes/{RouteIdentifier}";
    if (input.EnvironmentIdentifier !== undefined) {
        const labelValue = input.EnvironmentIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: EnvironmentIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{EnvironmentIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: EnvironmentIdentifier.");
    }
    if (input.ApplicationIdentifier !== undefined) {
        const labelValue = input.ApplicationIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ApplicationIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{ApplicationIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ApplicationIdentifier.");
    }
    if (input.RouteIdentifier !== undefined) {
        const labelValue = input.RouteIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: RouteIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{RouteIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: RouteIdentifier.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "DELETE",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DeleteRouteCommand = serializeAws_restJson1DeleteRouteCommand;
const serializeAws_restJson1DeleteServiceCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` +
        "/environments/{EnvironmentIdentifier}/applications/{ApplicationIdentifier}/services/{ServiceIdentifier}";
    if (input.EnvironmentIdentifier !== undefined) {
        const labelValue = input.EnvironmentIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: EnvironmentIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{EnvironmentIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: EnvironmentIdentifier.");
    }
    if (input.ApplicationIdentifier !== undefined) {
        const labelValue = input.ApplicationIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ApplicationIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{ApplicationIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ApplicationIdentifier.");
    }
    if (input.ServiceIdentifier !== undefined) {
        const labelValue = input.ServiceIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ServiceIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{ServiceIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ServiceIdentifier.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "DELETE",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DeleteServiceCommand = serializeAws_restJson1DeleteServiceCommand;
const serializeAws_restJson1GetApplicationCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` +
        "/environments/{EnvironmentIdentifier}/applications/{ApplicationIdentifier}";
    if (input.EnvironmentIdentifier !== undefined) {
        const labelValue = input.EnvironmentIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: EnvironmentIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{EnvironmentIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: EnvironmentIdentifier.");
    }
    if (input.ApplicationIdentifier !== undefined) {
        const labelValue = input.ApplicationIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ApplicationIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{ApplicationIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ApplicationIdentifier.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1GetApplicationCommand = serializeAws_restJson1GetApplicationCommand;
const serializeAws_restJson1GetEnvironmentCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/environments/{EnvironmentIdentifier}";
    if (input.EnvironmentIdentifier !== undefined) {
        const labelValue = input.EnvironmentIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: EnvironmentIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{EnvironmentIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: EnvironmentIdentifier.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1GetEnvironmentCommand = serializeAws_restJson1GetEnvironmentCommand;
const serializeAws_restJson1GetResourcePolicyCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/resourcepolicy/{Identifier}";
    if (input.Identifier !== undefined) {
        const labelValue = input.Identifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: Identifier.");
        }
        resolvedPath = resolvedPath.replace("{Identifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: Identifier.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1GetResourcePolicyCommand = serializeAws_restJson1GetResourcePolicyCommand;
const serializeAws_restJson1GetRouteCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` +
        "/environments/{EnvironmentIdentifier}/applications/{ApplicationIdentifier}/routes/{RouteIdentifier}";
    if (input.EnvironmentIdentifier !== undefined) {
        const labelValue = input.EnvironmentIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: EnvironmentIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{EnvironmentIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: EnvironmentIdentifier.");
    }
    if (input.ApplicationIdentifier !== undefined) {
        const labelValue = input.ApplicationIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ApplicationIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{ApplicationIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ApplicationIdentifier.");
    }
    if (input.RouteIdentifier !== undefined) {
        const labelValue = input.RouteIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: RouteIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{RouteIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: RouteIdentifier.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1GetRouteCommand = serializeAws_restJson1GetRouteCommand;
const serializeAws_restJson1GetServiceCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` +
        "/environments/{EnvironmentIdentifier}/applications/{ApplicationIdentifier}/services/{ServiceIdentifier}";
    if (input.EnvironmentIdentifier !== undefined) {
        const labelValue = input.EnvironmentIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: EnvironmentIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{EnvironmentIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: EnvironmentIdentifier.");
    }
    if (input.ApplicationIdentifier !== undefined) {
        const labelValue = input.ApplicationIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ApplicationIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{ApplicationIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ApplicationIdentifier.");
    }
    if (input.ServiceIdentifier !== undefined) {
        const labelValue = input.ServiceIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ServiceIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{ServiceIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ServiceIdentifier.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1GetServiceCommand = serializeAws_restJson1GetServiceCommand;
const serializeAws_restJson1ListApplicationsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` +
        "/environments/{EnvironmentIdentifier}/applications";
    if (input.EnvironmentIdentifier !== undefined) {
        const labelValue = input.EnvironmentIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: EnvironmentIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{EnvironmentIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: EnvironmentIdentifier.");
    }
    const query = {
        ...(input.NextToken !== undefined && { nextToken: input.NextToken }),
        ...(input.MaxResults !== undefined && { maxResults: input.MaxResults.toString() }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1ListApplicationsCommand = serializeAws_restJson1ListApplicationsCommand;
const serializeAws_restJson1ListEnvironmentsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/environments";
    const query = {
        ...(input.NextToken !== undefined && { nextToken: input.NextToken }),
        ...(input.MaxResults !== undefined && { maxResults: input.MaxResults.toString() }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1ListEnvironmentsCommand = serializeAws_restJson1ListEnvironmentsCommand;
const serializeAws_restJson1ListEnvironmentVpcsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` +
        "/environments/{EnvironmentIdentifier}/vpcs";
    if (input.EnvironmentIdentifier !== undefined) {
        const labelValue = input.EnvironmentIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: EnvironmentIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{EnvironmentIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: EnvironmentIdentifier.");
    }
    const query = {
        ...(input.NextToken !== undefined && { nextToken: input.NextToken }),
        ...(input.MaxResults !== undefined && { maxResults: input.MaxResults.toString() }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1ListEnvironmentVpcsCommand = serializeAws_restJson1ListEnvironmentVpcsCommand;
const serializeAws_restJson1ListRoutesCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` +
        "/environments/{EnvironmentIdentifier}/applications/{ApplicationIdentifier}/routes";
    if (input.EnvironmentIdentifier !== undefined) {
        const labelValue = input.EnvironmentIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: EnvironmentIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{EnvironmentIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: EnvironmentIdentifier.");
    }
    if (input.ApplicationIdentifier !== undefined) {
        const labelValue = input.ApplicationIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ApplicationIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{ApplicationIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ApplicationIdentifier.");
    }
    const query = {
        ...(input.NextToken !== undefined && { nextToken: input.NextToken }),
        ...(input.MaxResults !== undefined && { maxResults: input.MaxResults.toString() }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1ListRoutesCommand = serializeAws_restJson1ListRoutesCommand;
const serializeAws_restJson1ListServicesCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` +
        "/environments/{EnvironmentIdentifier}/applications/{ApplicationIdentifier}/services";
    if (input.EnvironmentIdentifier !== undefined) {
        const labelValue = input.EnvironmentIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: EnvironmentIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{EnvironmentIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: EnvironmentIdentifier.");
    }
    if (input.ApplicationIdentifier !== undefined) {
        const labelValue = input.ApplicationIdentifier;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ApplicationIdentifier.");
        }
        resolvedPath = resolvedPath.replace("{ApplicationIdentifier}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ApplicationIdentifier.");
    }
    const query = {
        ...(input.NextToken !== undefined && { nextToken: input.NextToken }),
        ...(input.MaxResults !== undefined && { maxResults: input.MaxResults.toString() }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1ListServicesCommand = serializeAws_restJson1ListServicesCommand;
const serializeAws_restJson1ListTagsForResourceCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/tags/{ResourceArn}";
    if (input.ResourceArn !== undefined) {
        const labelValue = input.ResourceArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ResourceArn.");
        }
        resolvedPath = resolvedPath.replace("{ResourceArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ResourceArn.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1ListTagsForResourceCommand = serializeAws_restJson1ListTagsForResourceCommand;
const serializeAws_restJson1PutResourcePolicyCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/resourcepolicy";
    let body;
    body = JSON.stringify({
        ...(input.Policy !== undefined && input.Policy !== null && { Policy: input.Policy }),
        ...(input.ResourceArn !== undefined && input.ResourceArn !== null && { ResourceArn: input.ResourceArn }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1PutResourcePolicyCommand = serializeAws_restJson1PutResourcePolicyCommand;
const serializeAws_restJson1TagResourceCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/tags/{ResourceArn}";
    if (input.ResourceArn !== undefined) {
        const labelValue = input.ResourceArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ResourceArn.");
        }
        resolvedPath = resolvedPath.replace("{ResourceArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ResourceArn.");
    }
    let body;
    body = JSON.stringify({
        ...(input.Tags !== undefined && input.Tags !== null && { Tags: serializeAws_restJson1TagMap(input.Tags, context) }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1TagResourceCommand = serializeAws_restJson1TagResourceCommand;
const serializeAws_restJson1UntagResourceCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/tags/{ResourceArn}";
    if (input.ResourceArn !== undefined) {
        const labelValue = input.ResourceArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: ResourceArn.");
        }
        resolvedPath = resolvedPath.replace("{ResourceArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: ResourceArn.");
    }
    const query = {
        ...(input.TagKeys !== undefined && { tagKeys: (input.TagKeys || []).map((_entry) => _entry) }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "DELETE",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1UntagResourceCommand = serializeAws_restJson1UntagResourceCommand;
const deserializeAws_restJson1CreateApplicationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1CreateApplicationCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ApiGatewayProxy: undefined,
        ApplicationId: undefined,
        Arn: undefined,
        CreatedByAccountId: undefined,
        CreatedTime: undefined,
        EnvironmentId: undefined,
        LastUpdatedTime: undefined,
        Name: undefined,
        OwnerAccountId: undefined,
        ProxyType: undefined,
        State: undefined,
        Tags: undefined,
        VpcId: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.ApiGatewayProxy !== undefined && data.ApiGatewayProxy !== null) {
        contents.ApiGatewayProxy = deserializeAws_restJson1ApiGatewayProxyInput(data.ApiGatewayProxy, context);
    }
    if (data.ApplicationId !== undefined && data.ApplicationId !== null) {
        contents.ApplicationId = (0, smithy_client_1.expectString)(data.ApplicationId);
    }
    if (data.Arn !== undefined && data.Arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.Arn);
    }
    if (data.CreatedByAccountId !== undefined && data.CreatedByAccountId !== null) {
        contents.CreatedByAccountId = (0, smithy_client_1.expectString)(data.CreatedByAccountId);
    }
    if (data.CreatedTime !== undefined && data.CreatedTime !== null) {
        contents.CreatedTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(data.CreatedTime)));
    }
    if (data.EnvironmentId !== undefined && data.EnvironmentId !== null) {
        contents.EnvironmentId = (0, smithy_client_1.expectString)(data.EnvironmentId);
    }
    if (data.LastUpdatedTime !== undefined && data.LastUpdatedTime !== null) {
        contents.LastUpdatedTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(data.LastUpdatedTime)));
    }
    if (data.Name !== undefined && data.Name !== null) {
        contents.Name = (0, smithy_client_1.expectString)(data.Name);
    }
    if (data.OwnerAccountId !== undefined && data.OwnerAccountId !== null) {
        contents.OwnerAccountId = (0, smithy_client_1.expectString)(data.OwnerAccountId);
    }
    if (data.ProxyType !== undefined && data.ProxyType !== null) {
        contents.ProxyType = (0, smithy_client_1.expectString)(data.ProxyType);
    }
    if (data.State !== undefined && data.State !== null) {
        contents.State = (0, smithy_client_1.expectString)(data.State);
    }
    if (data.Tags !== undefined && data.Tags !== null) {
        contents.Tags = deserializeAws_restJson1TagMap(data.Tags, context);
    }
    if (data.VpcId !== undefined && data.VpcId !== null) {
        contents.VpcId = (0, smithy_client_1.expectString)(data.VpcId);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1CreateApplicationCommand = deserializeAws_restJson1CreateApplicationCommand;
const deserializeAws_restJson1CreateApplicationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.migrationhubrefactorspaces#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.migrationhubrefactorspaces#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.migrationhubrefactorspaces#ServiceQuotaExceededException":
            throw await deserializeAws_restJson1ServiceQuotaExceededExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.migrationhubrefactorspaces#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1CreateEnvironmentCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1CreateEnvironmentCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Arn: undefined,
        CreatedTime: undefined,
        Description: undefined,
        EnvironmentId: undefined,
        LastUpdatedTime: undefined,
        Name: undefined,
        NetworkFabricType: undefined,
        OwnerAccountId: undefined,
        State: undefined,
        Tags: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.Arn !== undefined && data.Arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.Arn);
    }
    if (data.CreatedTime !== undefined && data.CreatedTime !== null) {
        contents.CreatedTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(data.CreatedTime)));
    }
    if (data.Description !== undefined && data.Description !== null) {
        contents.Description = (0, smithy_client_1.expectString)(data.Description);
    }
    if (data.EnvironmentId !== undefined && data.EnvironmentId !== null) {
        contents.EnvironmentId = (0, smithy_client_1.expectString)(data.EnvironmentId);
    }
    if (data.LastUpdatedTime !== undefined && data.LastUpdatedTime !== null) {
        contents.LastUpdatedTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(data.LastUpdatedTime)));
    }
    if (data.Name !== undefined && data.Name !== null) {
        contents.Name = (0, smithy_client_1.expectString)(data.Name);
    }
    if (data.NetworkFabricType !== undefined && data.NetworkFabricType !== null) {
        contents.NetworkFabricType = (0, smithy_client_1.expectString)(data.NetworkFabricType);
    }
    if (data.OwnerAccountId !== undefined && data.OwnerAccountId !== null) {
        contents.OwnerAccountId = (0, smithy_client_1.expectString)(data.OwnerAccountId);
    }
    if (data.State !== undefined && data.State !== null) {
        contents.State = (0, smithy_client_1.expectString)(data.State);
    }
    if (data.Tags !== undefined && data.Tags !== null) {
        contents.Tags = deserializeAws_restJson1TagMap(data.Tags, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1CreateEnvironmentCommand = deserializeAws_restJson1CreateEnvironmentCommand;
const deserializeAws_restJson1CreateEnvironmentCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.migrationhubrefactorspaces#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.migrationhubrefactorspaces#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.migrationhubrefactorspaces#ServiceQuotaExceededException":
            throw await deserializeAws_restJson1ServiceQuotaExceededExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.migrationhubrefactorspaces#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1CreateRouteCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1CreateRouteCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ApplicationId: undefined,
        Arn: undefined,
        CreatedByAccountId: undefined,
        CreatedTime: undefined,
        LastUpdatedTime: undefined,
        OwnerAccountId: undefined,
        RouteId: undefined,
        RouteType: undefined,
        ServiceId: undefined,
        State: undefined,
        Tags: undefined,
        UriPathRoute: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.ApplicationId !== undefined && data.ApplicationId !== null) {
        contents.ApplicationId = (0, smithy_client_1.expectString)(data.ApplicationId);
    }
    if (data.Arn !== undefined && data.Arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.Arn);
    }
    if (data.CreatedByAccountId !== undefined && data.CreatedByAccountId !== null) {
        contents.CreatedByAccountId = (0, smithy_client_1.expectString)(data.CreatedByAccountId);
    }
    if (data.CreatedTime !== undefined && data.CreatedTime !== null) {
        contents.CreatedTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(data.CreatedTime)));
    }
    if (data.LastUpdatedTime !== undefined && data.LastUpdatedTime !== null) {
        contents.LastUpdatedTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(data.LastUpdatedTime)));
    }
    if (data.OwnerAccountId !== undefined && data.OwnerAccountId !== null) {
        contents.OwnerAccountId = (0, smithy_client_1.expectString)(data.OwnerAccountId);
    }
    if (data.RouteId !== undefined && data.RouteId !== null) {
        contents.RouteId = (0, smithy_client_1.expectString)(data.RouteId);
    }
    if (data.RouteType !== undefined && data.RouteType !== null) {
        contents.RouteType = (0, smithy_client_1.expectString)(data.RouteType);
    }
    if (data.ServiceId !== undefined && data.ServiceId !== null) {
        contents.ServiceId = (0, smithy_client_1.expectString)(data.ServiceId);
    }
    if (data.State !== undefined && data.State !== null) {
        contents.State = (0, smithy_client_1.expectString)(data.State);
    }
    if (data.Tags !== undefined && data.Tags !== null) {
        contents.Tags = deserializeAws_restJson1TagMap(data.Tags, context);
    }
    if (data.UriPathRoute !== undefined && data.UriPathRoute !== null) {
        contents.UriPathRoute = deserializeAws_restJson1UriPathRouteInput(data.UriPathRoute, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1CreateRouteCommand = deserializeAws_restJson1CreateRouteCommand;
const deserializeAws_restJson1CreateRouteCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.migrationhubrefactorspaces#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.migrationhubrefactorspaces#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.migrationhubrefactorspaces#ServiceQuotaExceededException":
            throw await deserializeAws_restJson1ServiceQuotaExceededExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.migrationhubrefactorspaces#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1CreateServiceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1CreateServiceCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ApplicationId: undefined,
        Arn: undefined,
        CreatedByAccountId: undefined,
        CreatedTime: undefined,
        Description: undefined,
        EndpointType: undefined,
        EnvironmentId: undefined,
        LambdaEndpoint: undefined,
        LastUpdatedTime: undefined,
        Name: undefined,
        OwnerAccountId: undefined,
        ServiceId: undefined,
        State: undefined,
        Tags: undefined,
        UrlEndpoint: undefined,
        VpcId: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.ApplicationId !== undefined && data.ApplicationId !== null) {
        contents.ApplicationId = (0, smithy_client_1.expectString)(data.ApplicationId);
    }
    if (data.Arn !== undefined && data.Arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.Arn);
    }
    if (data.CreatedByAccountId !== undefined && data.CreatedByAccountId !== null) {
        contents.CreatedByAccountId = (0, smithy_client_1.expectString)(data.CreatedByAccountId);
    }
    if (data.CreatedTime !== undefined && data.CreatedTime !== null) {
        contents.CreatedTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(data.CreatedTime)));
    }
    if (data.Description !== undefined && data.Description !== null) {
        contents.Description = (0, smithy_client_1.expectString)(data.Description);
    }
    if (data.EndpointType !== undefined && data.EndpointType !== null) {
        contents.EndpointType = (0, smithy_client_1.expectString)(data.EndpointType);
    }
    if (data.EnvironmentId !== undefined && data.EnvironmentId !== null) {
        contents.EnvironmentId = (0, smithy_client_1.expectString)(data.EnvironmentId);
    }
    if (data.LambdaEndpoint !== undefined && data.LambdaEndpoint !== null) {
        contents.LambdaEndpoint = deserializeAws_restJson1LambdaEndpointInput(data.LambdaEndpoint, context);
    }
    if (data.LastUpdatedTime !== undefined && data.LastUpdatedTime !== null) {
        contents.LastUpdatedTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(data.LastUpdatedTime)));
    }
    if (data.Name !== undefined && data.Name !== null) {
        contents.Name = (0, smithy_client_1.expectString)(data.Name);
    }
    if (data.OwnerAccountId !== undefined && data.OwnerAccountId !== null) {
        contents.OwnerAccountId = (0, smithy_client_1.expectString)(data.OwnerAccountId);
    }
    if (data.ServiceId !== undefined && data.ServiceId !== null) {
        contents.ServiceId = (0, smithy_client_1.expectString)(data.ServiceId);
    }
    if (data.State !== undefined && data.State !== null) {
        contents.State = (0, smithy_client_1.expectString)(data.State);
    }
    if (data.Tags !== undefined && data.Tags !== null) {
        contents.Tags = deserializeAws_restJson1TagMap(data.Tags, context);
    }
    if (data.UrlEndpoint !== undefined && data.UrlEndpoint !== null) {
        contents.UrlEndpoint = deserializeAws_restJson1UrlEndpointInput(data.UrlEndpoint, context);
    }
    if (data.VpcId !== undefined && data.VpcId !== null) {
        contents.VpcId = (0, smithy_client_1.expectString)(data.VpcId);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1CreateServiceCommand = deserializeAws_restJson1CreateServiceCommand;
const deserializeAws_restJson1CreateServiceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.migrationhubrefactorspaces#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.migrationhubrefactorspaces#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.migrationhubrefactorspaces#ServiceQuotaExceededException":
            throw await deserializeAws_restJson1ServiceQuotaExceededExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.migrationhubrefactorspaces#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DeleteApplicationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DeleteApplicationCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ApplicationId: undefined,
        Arn: undefined,
        EnvironmentId: undefined,
        LastUpdatedTime: undefined,
        Name: undefined,
        State: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.ApplicationId !== undefined && data.ApplicationId !== null) {
        contents.ApplicationId = (0, smithy_client_1.expectString)(data.ApplicationId);
    }
    if (data.Arn !== undefined && data.Arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.Arn);
    }
    if (data.EnvironmentId !== undefined && data.EnvironmentId !== null) {
        contents.EnvironmentId = (0, smithy_client_1.expectString)(data.EnvironmentId);
    }
    if (data.LastUpdatedTime !== undefined && data.LastUpdatedTime !== null) {
        contents.LastUpdatedTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(data.LastUpdatedTime)));
    }
    if (data.Name !== undefined && data.Name !== null) {
        contents.Name = (0, smithy_client_1.expectString)(data.Name);
    }
    if (data.State !== undefined && data.State !== null) {
        contents.State = (0, smithy_client_1.expectString)(data.State);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DeleteApplicationCommand = deserializeAws_restJson1DeleteApplicationCommand;
const deserializeAws_restJson1DeleteApplicationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.migrationhubrefactorspaces#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.migrationhubrefactorspaces#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.migrationhubrefactorspaces#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DeleteEnvironmentCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DeleteEnvironmentCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Arn: undefined,
        EnvironmentId: undefined,
        LastUpdatedTime: undefined,
        Name: undefined,
        State: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.Arn !== undefined && data.Arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.Arn);
    }
    if (data.EnvironmentId !== undefined && data.EnvironmentId !== null) {
        contents.EnvironmentId = (0, smithy_client_1.expectString)(data.EnvironmentId);
    }
    if (data.LastUpdatedTime !== undefined && data.LastUpdatedTime !== null) {
        contents.LastUpdatedTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(data.LastUpdatedTime)));
    }
    if (data.Name !== undefined && data.Name !== null) {
        contents.Name = (0, smithy_client_1.expectString)(data.Name);
    }
    if (data.State !== undefined && data.State !== null) {
        contents.State = (0, smithy_client_1.expectString)(data.State);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DeleteEnvironmentCommand = deserializeAws_restJson1DeleteEnvironmentCommand;
const deserializeAws_restJson1DeleteEnvironmentCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.migrationhubrefactorspaces#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.migrationhubrefactorspaces#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.migrationhubrefactorspaces#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DeleteResourcePolicyCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DeleteResourcePolicyCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
    };
    await collectBody(output.body, context);
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DeleteResourcePolicyCommand = deserializeAws_restJson1DeleteResourcePolicyCommand;
const deserializeAws_restJson1DeleteResourcePolicyCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.migrationhubrefactorspaces#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.migrationhubrefactorspaces#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DeleteRouteCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DeleteRouteCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ApplicationId: undefined,
        Arn: undefined,
        LastUpdatedTime: undefined,
        RouteId: undefined,
        ServiceId: undefined,
        State: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.ApplicationId !== undefined && data.ApplicationId !== null) {
        contents.ApplicationId = (0, smithy_client_1.expectString)(data.ApplicationId);
    }
    if (data.Arn !== undefined && data.Arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.Arn);
    }
    if (data.LastUpdatedTime !== undefined && data.LastUpdatedTime !== null) {
        contents.LastUpdatedTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(data.LastUpdatedTime)));
    }
    if (data.RouteId !== undefined && data.RouteId !== null) {
        contents.RouteId = (0, smithy_client_1.expectString)(data.RouteId);
    }
    if (data.ServiceId !== undefined && data.ServiceId !== null) {
        contents.ServiceId = (0, smithy_client_1.expectString)(data.ServiceId);
    }
    if (data.State !== undefined && data.State !== null) {
        contents.State = (0, smithy_client_1.expectString)(data.State);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DeleteRouteCommand = deserializeAws_restJson1DeleteRouteCommand;
const deserializeAws_restJson1DeleteRouteCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.migrationhubrefactorspaces#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.migrationhubrefactorspaces#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.migrationhubrefactorspaces#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DeleteServiceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DeleteServiceCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ApplicationId: undefined,
        Arn: undefined,
        EnvironmentId: undefined,
        LastUpdatedTime: undefined,
        Name: undefined,
        ServiceId: undefined,
        State: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.ApplicationId !== undefined && data.ApplicationId !== null) {
        contents.ApplicationId = (0, smithy_client_1.expectString)(data.ApplicationId);
    }
    if (data.Arn !== undefined && data.Arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.Arn);
    }
    if (data.EnvironmentId !== undefined && data.EnvironmentId !== null) {
        contents.EnvironmentId = (0, smithy_client_1.expectString)(data.EnvironmentId);
    }
    if (data.LastUpdatedTime !== undefined && data.LastUpdatedTime !== null) {
        contents.LastUpdatedTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(data.LastUpdatedTime)));
    }
    if (data.Name !== undefined && data.Name !== null) {
        contents.Name = (0, smithy_client_1.expectString)(data.Name);
    }
    if (data.ServiceId !== undefined && data.ServiceId !== null) {
        contents.ServiceId = (0, smithy_client_1.expectString)(data.ServiceId);
    }
    if (data.State !== undefined && data.State !== null) {
        contents.State = (0, smithy_client_1.expectString)(data.State);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DeleteServiceCommand = deserializeAws_restJson1DeleteServiceCommand;
const deserializeAws_restJson1DeleteServiceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.migrationhubrefactorspaces#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.migrationhubrefactorspaces#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.migrationhubrefactorspaces#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1GetApplicationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1GetApplicationCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ApiGatewayProxy: undefined,
        ApplicationId: undefined,
        Arn: undefined,
        CreatedByAccountId: undefined,
        CreatedTime: undefined,
        EnvironmentId: undefined,
        Error: undefined,
        LastUpdatedTime: undefined,
        Name: undefined,
        OwnerAccountId: undefined,
        ProxyType: undefined,
        State: undefined,
        Tags: undefined,
        VpcId: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.ApiGatewayProxy !== undefined && data.ApiGatewayProxy !== null) {
        contents.ApiGatewayProxy = deserializeAws_restJson1ApiGatewayProxyConfig(data.ApiGatewayProxy, context);
    }
    if (data.ApplicationId !== undefined && data.ApplicationId !== null) {
        contents.ApplicationId = (0, smithy_client_1.expectString)(data.ApplicationId);
    }
    if (data.Arn !== undefined && data.Arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.Arn);
    }
    if (data.CreatedByAccountId !== undefined && data.CreatedByAccountId !== null) {
        contents.CreatedByAccountId = (0, smithy_client_1.expectString)(data.CreatedByAccountId);
    }
    if (data.CreatedTime !== undefined && data.CreatedTime !== null) {
        contents.CreatedTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(data.CreatedTime)));
    }
    if (data.EnvironmentId !== undefined && data.EnvironmentId !== null) {
        contents.EnvironmentId = (0, smithy_client_1.expectString)(data.EnvironmentId);
    }
    if (data.Error !== undefined && data.Error !== null) {
        contents.Error = deserializeAws_restJson1ErrorResponse(data.Error, context);
    }
    if (data.LastUpdatedTime !== undefined && data.LastUpdatedTime !== null) {
        contents.LastUpdatedTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(data.LastUpdatedTime)));
    }
    if (data.Name !== undefined && data.Name !== null) {
        contents.Name = (0, smithy_client_1.expectString)(data.Name);
    }
    if (data.OwnerAccountId !== undefined && data.OwnerAccountId !== null) {
        contents.OwnerAccountId = (0, smithy_client_1.expectString)(data.OwnerAccountId);
    }
    if (data.ProxyType !== undefined && data.ProxyType !== null) {
        contents.ProxyType = (0, smithy_client_1.expectString)(data.ProxyType);
    }
    if (data.State !== undefined && data.State !== null) {
        contents.State = (0, smithy_client_1.expectString)(data.State);
    }
    if (data.Tags !== undefined && data.Tags !== null) {
        contents.Tags = deserializeAws_restJson1TagMap(data.Tags, context);
    }
    if (data.VpcId !== undefined && data.VpcId !== null) {
        contents.VpcId = (0, smithy_client_1.expectString)(data.VpcId);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1GetApplicationCommand = deserializeAws_restJson1GetApplicationCommand;
const deserializeAws_restJson1GetApplicationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.migrationhubrefactorspaces#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.migrationhubrefactorspaces#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1GetEnvironmentCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1GetEnvironmentCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Arn: undefined,
        CreatedTime: undefined,
        Description: undefined,
        EnvironmentId: undefined,
        Error: undefined,
        LastUpdatedTime: undefined,
        Name: undefined,
        NetworkFabricType: undefined,
        OwnerAccountId: undefined,
        State: undefined,
        Tags: undefined,
        TransitGatewayId: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.Arn !== undefined && data.Arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.Arn);
    }
    if (data.CreatedTime !== undefined && data.CreatedTime !== null) {
        contents.CreatedTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(data.CreatedTime)));
    }
    if (data.Description !== undefined && data.Description !== null) {
        contents.Description = (0, smithy_client_1.expectString)(data.Description);
    }
    if (data.EnvironmentId !== undefined && data.EnvironmentId !== null) {
        contents.EnvironmentId = (0, smithy_client_1.expectString)(data.EnvironmentId);
    }
    if (data.Error !== undefined && data.Error !== null) {
        contents.Error = deserializeAws_restJson1ErrorResponse(data.Error, context);
    }
    if (data.LastUpdatedTime !== undefined && data.LastUpdatedTime !== null) {
        contents.LastUpdatedTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(data.LastUpdatedTime)));
    }
    if (data.Name !== undefined && data.Name !== null) {
        contents.Name = (0, smithy_client_1.expectString)(data.Name);
    }
    if (data.NetworkFabricType !== undefined && data.NetworkFabricType !== null) {
        contents.NetworkFabricType = (0, smithy_client_1.expectString)(data.NetworkFabricType);
    }
    if (data.OwnerAccountId !== undefined && data.OwnerAccountId !== null) {
        contents.OwnerAccountId = (0, smithy_client_1.expectString)(data.OwnerAccountId);
    }
    if (data.State !== undefined && data.State !== null) {
        contents.State = (0, smithy_client_1.expectString)(data.State);
    }
    if (data.Tags !== undefined && data.Tags !== null) {
        contents.Tags = deserializeAws_restJson1TagMap(data.Tags, context);
    }
    if (data.TransitGatewayId !== undefined && data.TransitGatewayId !== null) {
        contents.TransitGatewayId = (0, smithy_client_1.expectString)(data.TransitGatewayId);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1GetEnvironmentCommand = deserializeAws_restJson1GetEnvironmentCommand;
const deserializeAws_restJson1GetEnvironmentCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.migrationhubrefactorspaces#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.migrationhubrefactorspaces#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1GetResourcePolicyCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1GetResourcePolicyCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Policy: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.Policy !== undefined && data.Policy !== null) {
        contents.Policy = (0, smithy_client_1.expectString)(data.Policy);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1GetResourcePolicyCommand = deserializeAws_restJson1GetResourcePolicyCommand;
const deserializeAws_restJson1GetResourcePolicyCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.migrationhubrefactorspaces#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.migrationhubrefactorspaces#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1GetRouteCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1GetRouteCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ApplicationId: undefined,
        Arn: undefined,
        CreatedByAccountId: undefined,
        CreatedTime: undefined,
        EnvironmentId: undefined,
        Error: undefined,
        IncludeChildPaths: undefined,
        LastUpdatedTime: undefined,
        Methods: undefined,
        OwnerAccountId: undefined,
        PathResourceToId: undefined,
        RouteId: undefined,
        RouteType: undefined,
        ServiceId: undefined,
        SourcePath: undefined,
        State: undefined,
        Tags: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.ApplicationId !== undefined && data.ApplicationId !== null) {
        contents.ApplicationId = (0, smithy_client_1.expectString)(data.ApplicationId);
    }
    if (data.Arn !== undefined && data.Arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.Arn);
    }
    if (data.CreatedByAccountId !== undefined && data.CreatedByAccountId !== null) {
        contents.CreatedByAccountId = (0, smithy_client_1.expectString)(data.CreatedByAccountId);
    }
    if (data.CreatedTime !== undefined && data.CreatedTime !== null) {
        contents.CreatedTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(data.CreatedTime)));
    }
    if (data.EnvironmentId !== undefined && data.EnvironmentId !== null) {
        contents.EnvironmentId = (0, smithy_client_1.expectString)(data.EnvironmentId);
    }
    if (data.Error !== undefined && data.Error !== null) {
        contents.Error = deserializeAws_restJson1ErrorResponse(data.Error, context);
    }
    if (data.IncludeChildPaths !== undefined && data.IncludeChildPaths !== null) {
        contents.IncludeChildPaths = (0, smithy_client_1.expectBoolean)(data.IncludeChildPaths);
    }
    if (data.LastUpdatedTime !== undefined && data.LastUpdatedTime !== null) {
        contents.LastUpdatedTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(data.LastUpdatedTime)));
    }
    if (data.Methods !== undefined && data.Methods !== null) {
        contents.Methods = deserializeAws_restJson1HttpMethods(data.Methods, context);
    }
    if (data.OwnerAccountId !== undefined && data.OwnerAccountId !== null) {
        contents.OwnerAccountId = (0, smithy_client_1.expectString)(data.OwnerAccountId);
    }
    if (data.PathResourceToId !== undefined && data.PathResourceToId !== null) {
        contents.PathResourceToId = deserializeAws_restJson1PathResourceToId(data.PathResourceToId, context);
    }
    if (data.RouteId !== undefined && data.RouteId !== null) {
        contents.RouteId = (0, smithy_client_1.expectString)(data.RouteId);
    }
    if (data.RouteType !== undefined && data.RouteType !== null) {
        contents.RouteType = (0, smithy_client_1.expectString)(data.RouteType);
    }
    if (data.ServiceId !== undefined && data.ServiceId !== null) {
        contents.ServiceId = (0, smithy_client_1.expectString)(data.ServiceId);
    }
    if (data.SourcePath !== undefined && data.SourcePath !== null) {
        contents.SourcePath = (0, smithy_client_1.expectString)(data.SourcePath);
    }
    if (data.State !== undefined && data.State !== null) {
        contents.State = (0, smithy_client_1.expectString)(data.State);
    }
    if (data.Tags !== undefined && data.Tags !== null) {
        contents.Tags = deserializeAws_restJson1TagMap(data.Tags, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1GetRouteCommand = deserializeAws_restJson1GetRouteCommand;
const deserializeAws_restJson1GetRouteCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.migrationhubrefactorspaces#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.migrationhubrefactorspaces#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1GetServiceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1GetServiceCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ApplicationId: undefined,
        Arn: undefined,
        CreatedByAccountId: undefined,
        CreatedTime: undefined,
        Description: undefined,
        EndpointType: undefined,
        EnvironmentId: undefined,
        Error: undefined,
        LambdaEndpoint: undefined,
        LastUpdatedTime: undefined,
        Name: undefined,
        OwnerAccountId: undefined,
        ServiceId: undefined,
        State: undefined,
        Tags: undefined,
        UrlEndpoint: undefined,
        VpcId: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.ApplicationId !== undefined && data.ApplicationId !== null) {
        contents.ApplicationId = (0, smithy_client_1.expectString)(data.ApplicationId);
    }
    if (data.Arn !== undefined && data.Arn !== null) {
        contents.Arn = (0, smithy_client_1.expectString)(data.Arn);
    }
    if (data.CreatedByAccountId !== undefined && data.CreatedByAccountId !== null) {
        contents.CreatedByAccountId = (0, smithy_client_1.expectString)(data.CreatedByAccountId);
    }
    if (data.CreatedTime !== undefined && data.CreatedTime !== null) {
        contents.CreatedTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(data.CreatedTime)));
    }
    if (data.Description !== undefined && data.Description !== null) {
        contents.Description = (0, smithy_client_1.expectString)(data.Description);
    }
    if (data.EndpointType !== undefined && data.EndpointType !== null) {
        contents.EndpointType = (0, smithy_client_1.expectString)(data.EndpointType);
    }
    if (data.EnvironmentId !== undefined && data.EnvironmentId !== null) {
        contents.EnvironmentId = (0, smithy_client_1.expectString)(data.EnvironmentId);
    }
    if (data.Error !== undefined && data.Error !== null) {
        contents.Error = deserializeAws_restJson1ErrorResponse(data.Error, context);
    }
    if (data.LambdaEndpoint !== undefined && data.LambdaEndpoint !== null) {
        contents.LambdaEndpoint = deserializeAws_restJson1LambdaEndpointConfig(data.LambdaEndpoint, context);
    }
    if (data.LastUpdatedTime !== undefined && data.LastUpdatedTime !== null) {
        contents.LastUpdatedTime = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(data.LastUpdatedTime)));
    }
    if (data.Name !== undefined && data.Name !== null) {
        contents.Name = (0, smithy_client_1.expectString)(data.Name);
    }
    if (data.OwnerAccountId !== undefined && data.OwnerAccountId !== null) {
        contents.OwnerAccountId = (0, smithy_client_1.expectString)(data.OwnerAccountId);
    }
    if (data.ServiceId !== undefined && data.ServiceId !== null) {
        contents.ServiceId = (0, smithy_client_1.expectString)(data.ServiceId);
    }
    if (data.State !== undefined && data.State !== null) {
        contents.State = (0, smithy_client_1.expectString)(data.State);
    }
    if (data.Tags !== undefined && data.Tags !== null) {
        contents.Tags = deserializeAws_restJson1TagMap(data.Tags, context);
    }
    if (data.UrlEndpoint !== undefined && data.UrlEndpoint !== null) {
        contents.UrlEndpoint = deserializeAws_restJson1UrlEndpointConfig(data.UrlEndpoint, context);
    }
    if (data.VpcId !== undefined && data.VpcId !== null) {
        contents.VpcId = (0, smithy_client_1.expectString)(data.VpcId);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1GetServiceCommand = deserializeAws_restJson1GetServiceCommand;
const deserializeAws_restJson1GetServiceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.migrationhubrefactorspaces#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.migrationhubrefactorspaces#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListApplicationsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListApplicationsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        ApplicationSummaryList: undefined,
        NextToken: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.ApplicationSummaryList !== undefined && data.ApplicationSummaryList !== null) {
        contents.ApplicationSummaryList = deserializeAws_restJson1ApplicationSummaries(data.ApplicationSummaryList, context);
    }
    if (data.NextToken !== undefined && data.NextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.NextToken);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListApplicationsCommand = deserializeAws_restJson1ListApplicationsCommand;
const deserializeAws_restJson1ListApplicationsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.migrationhubrefactorspaces#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.migrationhubrefactorspaces#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.migrationhubrefactorspaces#ServiceQuotaExceededException":
            throw await deserializeAws_restJson1ServiceQuotaExceededExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.migrationhubrefactorspaces#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListEnvironmentsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListEnvironmentsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        EnvironmentSummaryList: undefined,
        NextToken: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.EnvironmentSummaryList !== undefined && data.EnvironmentSummaryList !== null) {
        contents.EnvironmentSummaryList = deserializeAws_restJson1EnvironmentSummaries(data.EnvironmentSummaryList, context);
    }
    if (data.NextToken !== undefined && data.NextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.NextToken);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListEnvironmentsCommand = deserializeAws_restJson1ListEnvironmentsCommand;
const deserializeAws_restJson1ListEnvironmentsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.migrationhubrefactorspaces#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.migrationhubrefactorspaces#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListEnvironmentVpcsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListEnvironmentVpcsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        EnvironmentVpcList: undefined,
        NextToken: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.EnvironmentVpcList !== undefined && data.EnvironmentVpcList !== null) {
        contents.EnvironmentVpcList = deserializeAws_restJson1EnvironmentVpcs(data.EnvironmentVpcList, context);
    }
    if (data.NextToken !== undefined && data.NextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.NextToken);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListEnvironmentVpcsCommand = deserializeAws_restJson1ListEnvironmentVpcsCommand;
const deserializeAws_restJson1ListEnvironmentVpcsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.migrationhubrefactorspaces#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.migrationhubrefactorspaces#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListRoutesCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListRoutesCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        NextToken: undefined,
        RouteSummaryList: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.NextToken !== undefined && data.NextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.NextToken);
    }
    if (data.RouteSummaryList !== undefined && data.RouteSummaryList !== null) {
        contents.RouteSummaryList = deserializeAws_restJson1RouteSummaries(data.RouteSummaryList, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListRoutesCommand = deserializeAws_restJson1ListRoutesCommand;
const deserializeAws_restJson1ListRoutesCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.migrationhubrefactorspaces#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.migrationhubrefactorspaces#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.migrationhubrefactorspaces#ServiceQuotaExceededException":
            throw await deserializeAws_restJson1ServiceQuotaExceededExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.migrationhubrefactorspaces#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListServicesCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListServicesCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        NextToken: undefined,
        ServiceSummaryList: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.NextToken !== undefined && data.NextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.NextToken);
    }
    if (data.ServiceSummaryList !== undefined && data.ServiceSummaryList !== null) {
        contents.ServiceSummaryList = deserializeAws_restJson1ServiceSummaries(data.ServiceSummaryList, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListServicesCommand = deserializeAws_restJson1ListServicesCommand;
const deserializeAws_restJson1ListServicesCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.migrationhubrefactorspaces#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.migrationhubrefactorspaces#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.migrationhubrefactorspaces#ServiceQuotaExceededException":
            throw await deserializeAws_restJson1ServiceQuotaExceededExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.migrationhubrefactorspaces#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListTagsForResourceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListTagsForResourceCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Tags: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.Tags !== undefined && data.Tags !== null) {
        contents.Tags = deserializeAws_restJson1TagMap(data.Tags, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListTagsForResourceCommand = deserializeAws_restJson1ListTagsForResourceCommand;
const deserializeAws_restJson1ListTagsForResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1PutResourcePolicyCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1PutResourcePolicyCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
    };
    await collectBody(output.body, context);
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1PutResourcePolicyCommand = deserializeAws_restJson1PutResourcePolicyCommand;
const deserializeAws_restJson1PutResourcePolicyCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.migrationhubrefactorspaces#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "InvalidResourcePolicyException":
        case "com.amazonaws.migrationhubrefactorspaces#InvalidResourcePolicyException":
            throw await deserializeAws_restJson1InvalidResourcePolicyExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.migrationhubrefactorspaces#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1TagResourceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1TagResourceCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
    };
    await collectBody(output.body, context);
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1TagResourceCommand = deserializeAws_restJson1TagResourceCommand;
const deserializeAws_restJson1TagResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1UntagResourceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1UntagResourceCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
    };
    await collectBody(output.body, context);
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1UntagResourceCommand = deserializeAws_restJson1UntagResourceCommand;
const deserializeAws_restJson1UntagResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalServerException":
        case "com.amazonaws.migrationhubrefactorspaces#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.migrationhubrefactorspaces#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.migrationhubrefactorspaces#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1AccessDeniedExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    const exception = new models_0_1.AccessDeniedException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ConflictExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    if (data.ResourceId !== undefined && data.ResourceId !== null) {
        contents.ResourceId = (0, smithy_client_1.expectString)(data.ResourceId);
    }
    if (data.ResourceType !== undefined && data.ResourceType !== null) {
        contents.ResourceType = (0, smithy_client_1.expectString)(data.ResourceType);
    }
    const exception = new models_0_1.ConflictException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1InternalServerExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    const exception = new models_0_1.InternalServerException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1InvalidResourcePolicyExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    const exception = new models_0_1.InvalidResourcePolicyException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ResourceNotFoundExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    if (data.ResourceId !== undefined && data.ResourceId !== null) {
        contents.ResourceId = (0, smithy_client_1.expectString)(data.ResourceId);
    }
    if (data.ResourceType !== undefined && data.ResourceType !== null) {
        contents.ResourceType = (0, smithy_client_1.expectString)(data.ResourceType);
    }
    const exception = new models_0_1.ResourceNotFoundException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ServiceQuotaExceededExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    if (data.QuotaCode !== undefined && data.QuotaCode !== null) {
        contents.QuotaCode = (0, smithy_client_1.expectString)(data.QuotaCode);
    }
    if (data.ResourceId !== undefined && data.ResourceId !== null) {
        contents.ResourceId = (0, smithy_client_1.expectString)(data.ResourceId);
    }
    if (data.ResourceType !== undefined && data.ResourceType !== null) {
        contents.ResourceType = (0, smithy_client_1.expectString)(data.ResourceType);
    }
    if (data.ServiceCode !== undefined && data.ServiceCode !== null) {
        contents.ServiceCode = (0, smithy_client_1.expectString)(data.ServiceCode);
    }
    const exception = new models_0_1.ServiceQuotaExceededException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ThrottlingExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    if (parsedOutput.headers["retry-after"] !== undefined) {
        contents.RetryAfterSeconds = (0, smithy_client_1.strictParseInt32)(parsedOutput.headers["retry-after"]);
    }
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    if (data.QuotaCode !== undefined && data.QuotaCode !== null) {
        contents.QuotaCode = (0, smithy_client_1.expectString)(data.QuotaCode);
    }
    if (data.ServiceCode !== undefined && data.ServiceCode !== null) {
        contents.ServiceCode = (0, smithy_client_1.expectString)(data.ServiceCode);
    }
    const exception = new models_0_1.ThrottlingException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ValidationExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    const exception = new models_0_1.ValidationException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const serializeAws_restJson1ApiGatewayProxyInput = (input, context) => {
    return {
        ...(input.EndpointType !== undefined && input.EndpointType !== null && { EndpointType: input.EndpointType }),
        ...(input.StageName !== undefined && input.StageName !== null && { StageName: input.StageName }),
    };
};
const serializeAws_restJson1HttpMethods = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_restJson1LambdaEndpointInput = (input, context) => {
    return {
        ...(input.Arn !== undefined && input.Arn !== null && { Arn: input.Arn }),
    };
};
const serializeAws_restJson1TagMap = (input, context) => {
    return Object.entries(input).reduce((acc, [key, value]) => {
        if (value === null) {
            return acc;
        }
        return {
            ...acc,
            [key]: value,
        };
    }, {});
};
const serializeAws_restJson1UriPathRouteInput = (input, context) => {
    return {
        ...(input.ActivationState !== undefined &&
            input.ActivationState !== null && { ActivationState: input.ActivationState }),
        ...(input.IncludeChildPaths !== undefined &&
            input.IncludeChildPaths !== null && { IncludeChildPaths: input.IncludeChildPaths }),
        ...(input.Methods !== undefined &&
            input.Methods !== null && { Methods: serializeAws_restJson1HttpMethods(input.Methods, context) }),
        ...(input.SourcePath !== undefined && input.SourcePath !== null && { SourcePath: input.SourcePath }),
    };
};
const serializeAws_restJson1UrlEndpointInput = (input, context) => {
    return {
        ...(input.HealthUrl !== undefined && input.HealthUrl !== null && { HealthUrl: input.HealthUrl }),
        ...(input.Url !== undefined && input.Url !== null && { Url: input.Url }),
    };
};
const deserializeAws_restJson1AdditionalDetails = (output, context) => {
    return Object.entries(output).reduce((acc, [key, value]) => {
        if (value === null) {
            return acc;
        }
        return {
            ...acc,
            [key]: (0, smithy_client_1.expectString)(value),
        };
    }, {});
};
const deserializeAws_restJson1ApiGatewayProxyConfig = (output, context) => {
    return {
        ApiGatewayId: (0, smithy_client_1.expectString)(output.ApiGatewayId),
        EndpointType: (0, smithy_client_1.expectString)(output.EndpointType),
        NlbArn: (0, smithy_client_1.expectString)(output.NlbArn),
        NlbName: (0, smithy_client_1.expectString)(output.NlbName),
        ProxyUrl: (0, smithy_client_1.expectString)(output.ProxyUrl),
        StageName: (0, smithy_client_1.expectString)(output.StageName),
        VpcLinkId: (0, smithy_client_1.expectString)(output.VpcLinkId),
    };
};
const deserializeAws_restJson1ApiGatewayProxyInput = (output, context) => {
    return {
        EndpointType: (0, smithy_client_1.expectString)(output.EndpointType),
        StageName: (0, smithy_client_1.expectString)(output.StageName),
    };
};
const deserializeAws_restJson1ApiGatewayProxySummary = (output, context) => {
    return {
        ApiGatewayId: (0, smithy_client_1.expectString)(output.ApiGatewayId),
        EndpointType: (0, smithy_client_1.expectString)(output.EndpointType),
        NlbArn: (0, smithy_client_1.expectString)(output.NlbArn),
        NlbName: (0, smithy_client_1.expectString)(output.NlbName),
        ProxyUrl: (0, smithy_client_1.expectString)(output.ProxyUrl),
        StageName: (0, smithy_client_1.expectString)(output.StageName),
        VpcLinkId: (0, smithy_client_1.expectString)(output.VpcLinkId),
    };
};
const deserializeAws_restJson1ApplicationSummaries = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1ApplicationSummary(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1ApplicationSummary = (output, context) => {
    return {
        ApiGatewayProxy: output.ApiGatewayProxy !== undefined && output.ApiGatewayProxy !== null
            ? deserializeAws_restJson1ApiGatewayProxySummary(output.ApiGatewayProxy, context)
            : undefined,
        ApplicationId: (0, smithy_client_1.expectString)(output.ApplicationId),
        Arn: (0, smithy_client_1.expectString)(output.Arn),
        CreatedByAccountId: (0, smithy_client_1.expectString)(output.CreatedByAccountId),
        CreatedTime: output.CreatedTime !== undefined && output.CreatedTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.CreatedTime)))
            : undefined,
        EnvironmentId: (0, smithy_client_1.expectString)(output.EnvironmentId),
        Error: output.Error !== undefined && output.Error !== null
            ? deserializeAws_restJson1ErrorResponse(output.Error, context)
            : undefined,
        LastUpdatedTime: output.LastUpdatedTime !== undefined && output.LastUpdatedTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.LastUpdatedTime)))
            : undefined,
        Name: (0, smithy_client_1.expectString)(output.Name),
        OwnerAccountId: (0, smithy_client_1.expectString)(output.OwnerAccountId),
        ProxyType: (0, smithy_client_1.expectString)(output.ProxyType),
        State: (0, smithy_client_1.expectString)(output.State),
        Tags: output.Tags !== undefined && output.Tags !== null
            ? deserializeAws_restJson1TagMap(output.Tags, context)
            : undefined,
        VpcId: (0, smithy_client_1.expectString)(output.VpcId),
    };
};
const deserializeAws_restJson1CidrBlocks = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return (0, smithy_client_1.expectString)(entry);
    });
    return retVal;
};
const deserializeAws_restJson1EnvironmentSummaries = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1EnvironmentSummary(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1EnvironmentSummary = (output, context) => {
    return {
        Arn: (0, smithy_client_1.expectString)(output.Arn),
        CreatedTime: output.CreatedTime !== undefined && output.CreatedTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.CreatedTime)))
            : undefined,
        Description: (0, smithy_client_1.expectString)(output.Description),
        EnvironmentId: (0, smithy_client_1.expectString)(output.EnvironmentId),
        Error: output.Error !== undefined && output.Error !== null
            ? deserializeAws_restJson1ErrorResponse(output.Error, context)
            : undefined,
        LastUpdatedTime: output.LastUpdatedTime !== undefined && output.LastUpdatedTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.LastUpdatedTime)))
            : undefined,
        Name: (0, smithy_client_1.expectString)(output.Name),
        NetworkFabricType: (0, smithy_client_1.expectString)(output.NetworkFabricType),
        OwnerAccountId: (0, smithy_client_1.expectString)(output.OwnerAccountId),
        State: (0, smithy_client_1.expectString)(output.State),
        Tags: output.Tags !== undefined && output.Tags !== null
            ? deserializeAws_restJson1TagMap(output.Tags, context)
            : undefined,
        TransitGatewayId: (0, smithy_client_1.expectString)(output.TransitGatewayId),
    };
};
const deserializeAws_restJson1EnvironmentVpc = (output, context) => {
    return {
        AccountId: (0, smithy_client_1.expectString)(output.AccountId),
        CidrBlocks: output.CidrBlocks !== undefined && output.CidrBlocks !== null
            ? deserializeAws_restJson1CidrBlocks(output.CidrBlocks, context)
            : undefined,
        CreatedTime: output.CreatedTime !== undefined && output.CreatedTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.CreatedTime)))
            : undefined,
        EnvironmentId: (0, smithy_client_1.expectString)(output.EnvironmentId),
        LastUpdatedTime: output.LastUpdatedTime !== undefined && output.LastUpdatedTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.LastUpdatedTime)))
            : undefined,
        VpcId: (0, smithy_client_1.expectString)(output.VpcId),
        VpcName: (0, smithy_client_1.expectString)(output.VpcName),
    };
};
const deserializeAws_restJson1EnvironmentVpcs = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1EnvironmentVpc(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1ErrorResponse = (output, context) => {
    return {
        AccountId: (0, smithy_client_1.expectString)(output.AccountId),
        AdditionalDetails: output.AdditionalDetails !== undefined && output.AdditionalDetails !== null
            ? deserializeAws_restJson1AdditionalDetails(output.AdditionalDetails, context)
            : undefined,
        Code: (0, smithy_client_1.expectString)(output.Code),
        Message: (0, smithy_client_1.expectString)(output.Message),
        ResourceIdentifier: (0, smithy_client_1.expectString)(output.ResourceIdentifier),
        ResourceType: (0, smithy_client_1.expectString)(output.ResourceType),
    };
};
const deserializeAws_restJson1HttpMethods = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return (0, smithy_client_1.expectString)(entry);
    });
    return retVal;
};
const deserializeAws_restJson1LambdaEndpointConfig = (output, context) => {
    return {
        Arn: (0, smithy_client_1.expectString)(output.Arn),
    };
};
const deserializeAws_restJson1LambdaEndpointInput = (output, context) => {
    return {
        Arn: (0, smithy_client_1.expectString)(output.Arn),
    };
};
const deserializeAws_restJson1LambdaEndpointSummary = (output, context) => {
    return {
        Arn: (0, smithy_client_1.expectString)(output.Arn),
    };
};
const deserializeAws_restJson1PathResourceToId = (output, context) => {
    return Object.entries(output).reduce((acc, [key, value]) => {
        if (value === null) {
            return acc;
        }
        return {
            ...acc,
            [key]: (0, smithy_client_1.expectString)(value),
        };
    }, {});
};
const deserializeAws_restJson1RouteSummaries = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1RouteSummary(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1RouteSummary = (output, context) => {
    return {
        ApplicationId: (0, smithy_client_1.expectString)(output.ApplicationId),
        Arn: (0, smithy_client_1.expectString)(output.Arn),
        CreatedByAccountId: (0, smithy_client_1.expectString)(output.CreatedByAccountId),
        CreatedTime: output.CreatedTime !== undefined && output.CreatedTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.CreatedTime)))
            : undefined,
        EnvironmentId: (0, smithy_client_1.expectString)(output.EnvironmentId),
        Error: output.Error !== undefined && output.Error !== null
            ? deserializeAws_restJson1ErrorResponse(output.Error, context)
            : undefined,
        IncludeChildPaths: (0, smithy_client_1.expectBoolean)(output.IncludeChildPaths),
        LastUpdatedTime: output.LastUpdatedTime !== undefined && output.LastUpdatedTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.LastUpdatedTime)))
            : undefined,
        Methods: output.Methods !== undefined && output.Methods !== null
            ? deserializeAws_restJson1HttpMethods(output.Methods, context)
            : undefined,
        OwnerAccountId: (0, smithy_client_1.expectString)(output.OwnerAccountId),
        PathResourceToId: output.PathResourceToId !== undefined && output.PathResourceToId !== null
            ? deserializeAws_restJson1PathResourceToId(output.PathResourceToId, context)
            : undefined,
        RouteId: (0, smithy_client_1.expectString)(output.RouteId),
        RouteType: (0, smithy_client_1.expectString)(output.RouteType),
        ServiceId: (0, smithy_client_1.expectString)(output.ServiceId),
        SourcePath: (0, smithy_client_1.expectString)(output.SourcePath),
        State: (0, smithy_client_1.expectString)(output.State),
        Tags: output.Tags !== undefined && output.Tags !== null
            ? deserializeAws_restJson1TagMap(output.Tags, context)
            : undefined,
    };
};
const deserializeAws_restJson1ServiceSummaries = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1ServiceSummary(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1ServiceSummary = (output, context) => {
    return {
        ApplicationId: (0, smithy_client_1.expectString)(output.ApplicationId),
        Arn: (0, smithy_client_1.expectString)(output.Arn),
        CreatedByAccountId: (0, smithy_client_1.expectString)(output.CreatedByAccountId),
        CreatedTime: output.CreatedTime !== undefined && output.CreatedTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.CreatedTime)))
            : undefined,
        Description: (0, smithy_client_1.expectString)(output.Description),
        EndpointType: (0, smithy_client_1.expectString)(output.EndpointType),
        EnvironmentId: (0, smithy_client_1.expectString)(output.EnvironmentId),
        Error: output.Error !== undefined && output.Error !== null
            ? deserializeAws_restJson1ErrorResponse(output.Error, context)
            : undefined,
        LambdaEndpoint: output.LambdaEndpoint !== undefined && output.LambdaEndpoint !== null
            ? deserializeAws_restJson1LambdaEndpointSummary(output.LambdaEndpoint, context)
            : undefined,
        LastUpdatedTime: output.LastUpdatedTime !== undefined && output.LastUpdatedTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.LastUpdatedTime)))
            : undefined,
        Name: (0, smithy_client_1.expectString)(output.Name),
        OwnerAccountId: (0, smithy_client_1.expectString)(output.OwnerAccountId),
        ServiceId: (0, smithy_client_1.expectString)(output.ServiceId),
        State: (0, smithy_client_1.expectString)(output.State),
        Tags: output.Tags !== undefined && output.Tags !== null
            ? deserializeAws_restJson1TagMap(output.Tags, context)
            : undefined,
        UrlEndpoint: output.UrlEndpoint !== undefined && output.UrlEndpoint !== null
            ? deserializeAws_restJson1UrlEndpointSummary(output.UrlEndpoint, context)
            : undefined,
        VpcId: (0, smithy_client_1.expectString)(output.VpcId),
    };
};
const deserializeAws_restJson1TagMap = (output, context) => {
    return Object.entries(output).reduce((acc, [key, value]) => {
        if (value === null) {
            return acc;
        }
        return {
            ...acc,
            [key]: (0, smithy_client_1.expectString)(value),
        };
    }, {});
};
const deserializeAws_restJson1UriPathRouteInput = (output, context) => {
    return {
        ActivationState: (0, smithy_client_1.expectString)(output.ActivationState),
        IncludeChildPaths: (0, smithy_client_1.expectBoolean)(output.IncludeChildPaths),
        Methods: output.Methods !== undefined && output.Methods !== null
            ? deserializeAws_restJson1HttpMethods(output.Methods, context)
            : undefined,
        SourcePath: (0, smithy_client_1.expectString)(output.SourcePath),
    };
};
const deserializeAws_restJson1UrlEndpointConfig = (output, context) => {
    return {
        HealthUrl: (0, smithy_client_1.expectString)(output.HealthUrl),
        Url: (0, smithy_client_1.expectString)(output.Url),
    };
};
const deserializeAws_restJson1UrlEndpointInput = (output, context) => {
    return {
        HealthUrl: (0, smithy_client_1.expectString)(output.HealthUrl),
        Url: (0, smithy_client_1.expectString)(output.Url),
    };
};
const deserializeAws_restJson1UrlEndpointSummary = (output, context) => {
    return {
        HealthUrl: (0, smithy_client_1.expectString)(output.HealthUrl),
        Url: (0, smithy_client_1.expectString)(output.Url),
    };
};
const deserializeMetadata = (output) => {
    var _a;
    return ({
        httpStatusCode: output.statusCode,
        requestId: (_a = output.headers["x-amzn-requestid"]) !== null && _a !== void 0 ? _a : output.headers["x-amzn-request-id"],
        extendedRequestId: output.headers["x-amz-id-2"],
        cfId: output.headers["x-amz-cf-id"],
    });
};
const collectBody = (streamBody = new Uint8Array(), context) => {
    if (streamBody instanceof Uint8Array) {
        return Promise.resolve(streamBody);
    }
    return context.streamCollector(streamBody) || Promise.resolve(new Uint8Array());
};
const collectBodyString = (streamBody, context) => collectBody(streamBody, context).then((body) => context.utf8Encoder(body));
const isSerializableHeaderValue = (value) => value !== undefined &&
    value !== null &&
    value !== "" &&
    (!Object.getOwnPropertyNames(value).includes("length") || value.length != 0) &&
    (!Object.getOwnPropertyNames(value).includes("size") || value.size != 0);
const parseBody = (streamBody, context) => collectBodyString(streamBody, context).then((encoded) => {
    if (encoded.length) {
        return JSON.parse(encoded);
    }
    return {};
});
const loadRestJsonErrorCode = (output, data) => {
    const findKey = (object, key) => Object.keys(object).find((k) => k.toLowerCase() === key.toLowerCase());
    const sanitizeErrorCode = (rawValue) => {
        let cleanValue = rawValue;
        if (cleanValue.indexOf(":") >= 0) {
            cleanValue = cleanValue.split(":")[0];
        }
        if (cleanValue.indexOf("#") >= 0) {
            cleanValue = cleanValue.split("#")[1];
        }
        return cleanValue;
    };
    const headerKey = findKey(output.headers, "x-amzn-errortype");
    if (headerKey !== undefined) {
        return sanitizeErrorCode(output.headers[headerKey]);
    }
    if (data.code !== undefined) {
        return sanitizeErrorCode(data.code);
    }
    if (data["__type"] !== undefined) {
        return sanitizeErrorCode(data["__type"]);
    }
    return "";
};
